/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginReverseSocket = {};
pluginReverseSocket.localization = {};
/****************************/

// Plugin details
var pluginName = "ReverseSocket";
var _plugin = $("#pnlPlugin" + pluginName);

// Localizations
pluginReverseSocket.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblVersionText : "Version : ",
	lblServerLocationText : "Server Location : ",
	lblExternalText : "External (DMZ)",
	lblInternalText : "Internal",
	lblExternalTabText : "External",
	lblInternalTabText : "Internal",
	lblServerIPText : "server IP : ",
	lblServerPortText : "server port : ",
	lblPrivateServerIPText : "Private server IP : ",
	lblPrivateServerPortText : "Private server port : ",
	lblIPsToAcceptRequestFromText : "IPs to accept request from : ",
	lblPortsToReceiveRequestsOnText : "Port to receive requests on : ",
	lblPortRangeText : "Port range for FTP ACTIVE mode : "
};

// Assign localizations
localizations.panels["Plugins"][pluginName] = $.extend(pluginReverseSocket.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginReverseSocket.init = function(pluginID, returnXML){
	pluginReverseSocket.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	pluginReverseSocket.bindData(0, pluginID);
}

pluginReverseSocket.bindData = function(index, pluginID)
{
	index = index || 0;
	var pluginPrefs = [];
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		pluginReverseSocket.bindPluginDetails(curPlugin);
		pluginReverseSocket.bindEvents();
		if(_plugin.find("#external").is(":checked"))
		{
			_plugin.find("a[rel='external']").trigger("click");
		}
		else
		{
			_plugin.find("a[rel='internal']").trigger("click");
		}
	}
	else
	{
		pluginReverseSocket.bindEvents();
	}
}

pluginReverseSocket.bindEvents = function()
{
	_plugin.find("input[name='server_type']").bind("change", function(){
		_plugin.find("div.tabs").tabs("destroy");
		_plugin.find("div.tabs").tabs({load : function(event, ui){
			if(ui.index==0)
				_plugin.find("#external").attr("checked","checked");
			else
				_plugin.find("#internal").attr("checked","checked");
		}});
		if(_plugin.find("#external").is(":checked"))
		{
			_plugin.find("a[rel='external']").trigger("click");
		}
		else
		{
			_plugin.find("a[rel='internal']").trigger("click");
		}
	});

	_plugin.find("input, select, textarea").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginReverseSocket.returnXML, pluginName);
	});

	_plugin.find("input[type='text'], textarea").unbind("textchange").bind("textchange", function(){
		panelPlugins.itemsChanged(true, pluginReverseSocket.returnXML, pluginName);
	});
}

pluginReverseSocket.bindPluginDetails = function(controlData)
{
	var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(_plugin, controlData);
	if(controlData.subItem && controlData.subItem.length>0)
		_plugin.attr("subPluginName", controlData.subItem[0].text || false);
	inputs.addClass("ignoreBind");

	if(controlData.external[0].text == "true")
	{
		checkUnchekInput(_plugin.find("#external"), true);
		_plugin.find("a[rel='external']").trigger("click");
	}
	else if(controlData.internal[0].text == "true")
	{
		checkUnchekInput(_plugin.find("#internal"), true);
		_plugin.find("a[rel='internal']").trigger("click");
	}
}

pluginReverseSocket.saveContent = function(saveByIndex, cloneName, removeByIndex, callback)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginReverseSocket.returnXML)
	{
		if(!pluginReverseSocket.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");

		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", _plugin).text()+"</version>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
			xmlString.push(buildXMLToSubmitForm(_plugin, true));
			inputs.addClass("ignoreBind");
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");

		if(pluginReverseSocket.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}